Summary: Secure Shell - provides secure encrypted network communications
Summary(ko): Ƚ - ϰ ȣȭ Ʈũ  
Name: ssh2
Version: 3.2.0
Release: 1kr
Source0: ftp://ftp.ssh.com/pub/ssh/ssh-%{version}.tar.gz
Source1: ssh2.pam
Source2: sshd2.init
Patch0: ssh2_config.patch
URL: http://www.ssh.com
Copyright: Free for non-commercial use (see LICENSING)
Group: Networking/Utilities
Buildroot: /var/tmp/ssh2-buildroot

Packager: JoungKyun. Kim <http://www.oops.org>
Vendor: OOPS Development ORG

%description
Secure Shell (ssh) provides secure encrypted communication between hosts
over an insecure network. It also has the ability to redirect X11 connections
and arbitrary TCP/IP ports over the secure encrypted channel.

SSHv2 is an almost complete rewrite of SSH. It provides a number of
enhancements over the previous version (SSHv1). One of them is the utility
sftp that permits encrypted file transfers.

SSHv2 needs the SSHv1 programs for backwards compatibility, so if you need
to connect to SSHv1 servers or clients you need to install SSHv1 BEFORE
these packages...

This is a base package. To use ssh you will need to install at least
ssh-clients or ssh-server.

%description -l ko
Ƚ(ssh)    ȣƮ鰣 ϰ ȣȭ  Ѵ.
H X11  redirect  ϸ, ȣȭ ä󿡼  TCP/IP Ʈ
 Ѵ.

SSHv2  SSHv1  ׷̵ Ѱ ƴ϶   ۼ ̸,  
 (SSHv1)  ũ ȭǾ. ȭ  ǥ    
ȣȭ (sftp) ϰ  ̴.

SSHv1  ȣѵǰ Ϸ SSHv2  ġϱ  SSHv1  ̸ ġ ؾ
Ѵ.

 Ű ⺻ Ű̸, ssh  Կ ־ ssh-clients  ssh-server
 ġؾ Ѵ.

# Base package files
%files
%attr(-,root,root) %doc BUG.REPORT CHANGES FAQ INSTALL LICENSE
%attr(-,root,root) %doc MANIFEST README SSH2.QUICKSTART
%attr(0755,root,root) /usr/bin/ssh-keygen2
%attr(0755,root,root) /usr/bin/scp2
%attr(0755,root,root) /usr/bin/ssh-dummy-shell
%attr(0755,root,root) /usr/bin/ssh-dummy-shell.static
%attr(0755,root,root) /usr/bin/ssh-chrootmgr
%attr(0644,root,root) %{_mandir}/man1/ssh-keygen2.1.gz
%attr(0644,root,root) %{_mandir}/man1/scp2.1.gz
%attr(0644,root,root) %{_mandir}/man1/ssh-dummy-shell.1.gz
%attr(0644,root,root) %{_mandir}/man1/ssh-chrootmgr.1.gz
#%attr(-,root,root) %ghost /usr/bin/ssh-keygen
#%attr(-,root,root) %ghost /usr/bin/scp
#%attr(-,root,root) %ghost %{_mandir}/man1/ssh-keygen.1
#%attr(-,root,root) %ghost %{_mandir}/man1/scp.1
%attr(0755,root,root) %dir /etc/ssh2

%post
# Fix symlinks in binary utils
for i in /usr/bin/ssh-keygen /usr/bin/scp; do
  ln -sf `basename $i`2 $i
done

# Fix symlinks in manpages
for i in %{_mandir}/man1/ssh-keygen.1.gz %{_mandir}/man1/scp.1.gz; do
  CHAPTER=${i#*.}; PROG=${i%.$CHAPTER}
  ln -sf `basename $PROG`2.$CHAPTER ${PROG}.$CHAPTER
done

# Generate hostkey
if [ ! -f /etc/ssh2/hostkey -o ! -s /etc/ssh2/hostkey ]; then
   umask 022; \
   echo "Generating 1024 bit host key. This may take a while, go and have a coffee ;)"; \
   /usr/bin/ssh-keygen2 -P -b 1024 -t dsa -c "1024-bit dsa hostkey" /etc/ssh2/hostkey
fi

%preun
# If last instance..
if [ "$1" = 0 ]; then
   # Symlink to SSHv1 utils if they exist, or delete symlink if they don't
   for i in /usr/bin/ssh-keygen /usr/bin/scp; do
     if [ -f "$i"1 ]; then
        ln -sf `basename $i`1 $i
     else
        rm -f $i
     fi
   done
   # Symlink to SSHv1 manpages if they exist, or delete symlink if they don't
   for i in %{_mandir}/man1/ssh-keygen.1.gz %{_mandir}/man1/scp.1.gz; do
     CHAPTER=${i#*.}; PROG=${i%.$CHAPTER}
     if [ -f "$PROG"1.$CHAPTER ]; then
        ln -sf `basename $PROG`1.$CHAPTER ${PROG}.$CHAPTER
     else
        rm -f $i
     fi   
   done
fi

%package server
#-------------------- ssh-server sub-package ----------------------- 
Group: Networking/Daemons
Summary: Secure Shell servers (sshd, sftp-server)
Summary(ko): Ƚ  (sshd, sftp-server)
Requires: ssh2 >= 3.0.0 chkconfig >= 0.9

%description server
This package contains the secure shell servers and its documentation.
These servers allows ssh clients to connect to your host. 

%description server -l ko
 Ű Ƚ  α׷  ϰ ִ.  
ssh client   ϰ ش.

It (still?) doesn't support PAM...

%files server
%attr(0644,root,root) %config /etc/ssh2/sshd2_config
%attr(0755,root,root) /usr/sbin/sshd2
%attr(0755,root,root) /usr/bin/sftp-server2
%attr(0755,root,root) /usr/bin/sftp-server2.static
%attr(0644,root,root) %{_mandir}/man8/sshd2.8.gz
%attr(0644,root,root) %{_mandir}/man5/sshd2_config.5.gz
%attr(0644,root,root) %{_mandir}/man5/sshd-check-conf.5.gz
#%attr(-,root,root) %ghost /usr/sbin/sshd
#%attr(-,root,root) %ghost /usr/bin/sftp-server
#%attr(-,root,root) %ghost %{_mandir}/man8/sshd.8
%attr(0644,root,root) /etc/pam.d/sshd2
%attr(0755,root,root) /etc/rc.d/init.d/sshd2

%post server
# Fix symlinks in binary utils
for i in /usr/sbin/sshd /usr/bin/sftp-server; do
  ln -sf `basename $i`2 $i
done

# Fix symlinks in manpages
for i in %{_mandir}/man8/sshd.8.gz; do
  CHAPTER=${i#*.}; PROG=${i%.$CHAPTER}
  ln -sf `basename $PROG`2.$CHAPTER ${PROG}.$CHAPTER
done

# If sshd1 is configured to run, delete it...
if /sbin/chkconfig sshd; then
   echo "executing: chkconfig --del sshd"
   /sbin/chkconfig --del sshd 
fi

# Install init scripts and start service
/sbin/chkconfig --add sshd2

%preun server
# If last instance..
if [ "$1" = 0 ]; then
   # Uninstall init scripts and stop service
   /etc/rc.d/init.d/sshd2 stop >&2
   /sbin/chkconfig --del sshd2
   
   # If we have SSHv1, chkconfig it..
   if [ -f /etc/rc.d/init.d/sshd ]; then
      echo "executing: chkconfig --add sshd"
      /sbin/chkconfig --add sshd
   fi
   
   # Symlink to SSHv1 utils if they exist, or delete symlink if they don't
   for i in /usr/sbin/sshd /usr/bin/sftp-server; do
     if [ -f "$i"1 ]; then
        ln -sf `basename $i`1 $i
     else
        rm -f $i
     fi
   done
   # Symlink to SSHv1 manpages if they exist, or delete symlink if they don't
   for i in %{_mandir}/man8/sshd.8.gz; do
     CHAPTER=${i#*.}; PROG=${i%.$CHAPTER}
     if [ -f "$PROG"1.$CHAPTER ]; then
        ln -sf `basename $PROG`1.$CHAPTER ${PROG}.$CHAPTER
     else
        rm -f $i
     fi   
   done
fi

%package clients
#-------------------- ssh-clients sub-package ----------------------- 
Summary: Clients to connect to SSH Servers
Summary(ko): SSH  ϱ  Ŭ̾Ʈ α׷
Group: Networking/Utilities
Requires: ssh2 >= 3.0.0

%description clients
This package contains the clients needed to make encrypted connections to
ssh servers.

%description clients -l ko
 Ű ssh  ȣȭǾ  ϱ  Ŭ̾Ʈ α׷
Ѵ.

%files clients
%attr(0644,root,root) %config /etc/ssh2/ssh2_config
%attr(0755,root,root) /usr/bin/ssh2
%attr(0755,root,root) /usr/bin/ssh-agent2
%attr(0755,root,root) /usr/bin/ssh-add2
%attr(0755,root,root) /usr/bin/sftp2
%attr(0644,root,root) %{_mandir}/man1/ssh2.1.gz
%attr(0644,root,root) %{_mandir}/man5/ssh2_config.5.gz
%attr(0644,root,root) %{_mandir}/man1/ssh-agent2.1.gz
%attr(0644,root,root) %{_mandir}/man1/ssh-add2.1.gz
%attr(0644,root,root) %{_mandir}/man1/sftp2.1.gz
#%attr(-,root,root) %ghost /usr/bin/ssh
#%attr(-,root,root) %ghost /usr/bin/ssh-agent
#%attr(-,root,root) %ghost /usr/bin/ssh-add
#%attr(-,root,root) %ghost /usr/bin/sftp
#%attr(-,root,root) %ghost %{_mandir}/man1/ssh.1
#%attr(-,root,root) %ghost %{_mandir}/man1/ssh-agent.1
#%attr(-,root,root) %ghost %{_mandir}/man1/ssh-add.1
#%attr(-,root,root) %ghost %{_mandir}/man1/sftp.1

%post clients
# Fix symlinks in binary utils
for i in /usr/bin/ssh /usr/bin/ssh-agent /usr/bin/ssh-add /usr/bin/sftp; do
  ln -sf `basename $i`2 $i
done

# Fix symlinks in manpages
for i in %{_mandir}/man1/ssh.1.gz %{_mandir}/man1/ssh-agent.1.gz \
         %{_mandir}/man1/ssh-add.1.gz %{_mandir}/man1/sftp.1.gz; do
  CHAPTER=${i#*.}; PROG=${i%.$CHAPTER}
  ln -sf `basename $PROG`2.$CHAPTER ${PROG}.$CHAPTER
done

%preun clients
# If last instance..
if [ "$1" = 0 ]; then
   # Symlink to SSHv1 utils if they exist, or delete symlink if they don't
   for i in /usr/bin/ssh /usr/bin/ssh-agent /usr/bin/ssh-add /usr/bin/sftp; do
     if [ -f "$i"1 ]; then
        ln -sf `basename $i`1 $i
     else
        rm -f $i
     fi
   done
   # Symlink to SSHv1 manpages if they exist, or delete symlink if they don't
   for i in %{_mandir}/man1/ssh.1.gz %{_mandir}/man1/ssh-agent.1.gz \
         %{_mandir}/man1/ssh-add.1.gz %{_mandir}/man1/sftp.1.gz; do
     CHAPTER=${i#*.}; PROG=${i%.$CHAPTER}
     if [ -f "$PROG"1.$CHAPTER ]; then
        ln -sf `basename $PROG`1.$CHAPTER ${PROG}.$CHAPTER
     else
        rm -f $i
     fi   
   done
fi

%package extras
#-------------------- ssh-extras sub-package ----------------------- 
Summary: Extra commands for the Secure Shell utils
Summary(ko): Ƚ  Ư ƿƼ
Group: Networking/Utilities
Requires: ssh2 >= 3.0.0

%description extras
This package contains the make_ssh_known_hosts
the ssh-askpass command and its documentation. They were moved
to the separate package to allow clean install of ssh even
on X11-less and perl-less machines (make_ssh_known_hosts is a perl script
and ssh-askpass uses X11 libraries.

%description extras -l ko
 Ű host key    ssh-askpass ɰ   
Ǿ ִ.

%files extras
%attr(0755,root,root) /usr/bin/ssh-askpass2
%attr(0755,root,root) /usr/bin/ssh-probe2
%attr(0755,root,root) /usr/bin/ssh-pubkeymgr
%attr(0755,root,root) /usr/bin/ssh-signer2
#%attr(0755,root,root) /usr/bin/ssh-pam-client
#%attr(-,root,root) %ghost /usr/bin/ssh-askpass

%post extras
# Fix symlinks in binary utils
for i in /usr/bin/ssh-askpass; do
  ln -sf `basename $i`2 $i
done

%preun extras
# If last instance..
if [ "$1" = 0 ]; then
   # Symlink to SSHv1 utils if they exist, or delete symlink if they don't
   for i in /usr/bin/ssh-askpass; do
     if [ -f "$i"1 ]; then
        ln -sf `basename $i`1 $i
     else
        rm -f $i
     fi
   done
fi

#---------------- end of sub-package definitions -------------------
%prep
%setup -n ssh-${RPM_PACKAGE_VERSION}

%patch0 -p1

%build
CFLAGS=$RPM_OPT_FLAGS \
./configure --prefix=/usr \
	--mandir=%{_mandir} \
	--enable-static \
	--with-libwrap \
	--with-daemon-pam-service-name=sshd2 \
	--enable-debug-heavy
CFLAGS=$RPM_OPT_FLAGS make

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/usr $RPM_BUILD_ROOT/etc/rc.d/init.d $RPM_BUILD_ROOT/etc/pam.d
make prefix=$RPM_BUILD_ROOT/usr etcdir=$RPM_BUILD_ROOT/etc/ssh2 mandir=$RPM_BUILD_ROOT%{_mandir} install
install -m644 %{SOURCE1} $RPM_BUILD_ROOT/etc/pam.d/sshd2
install -m755 %{SOURCE2} $RPM_BUILD_ROOT/etc/rc.d/init.d/sshd2
strip $RPM_BUILD_ROOT/usr/bin/{scp*,sftp*,ssh,ssh-a*,ssh-d*,ssh-k*,ssh-pro*,ssh-s*,ssh2}
strip $RPM_BUILD_ROOT/usr/sbin/* 

%clean
rm -rf $RPM_BUILD_ROOT

%changelog
* Wed Jun 26 2002 JoungKyun Kim <http://www.oops.org>
- release 3.2.0

* Thu May 30 2002 JoungKyun Kim <http://www.oops.org>
- release 3.1.2

* Thu Jan 16 2002 JoungKyun Kim <http://www.oops.org>
- release 3.1.0

* Mon Jul 30 2001 JoungKyun Kim <http://www.oops.org>
- release 3.0.1

* Thu Jul  5 2001 JoungKyun Kim <http://www.oops.org>
- rebuild with enable static mode cause of
  enable ChRoot environment

* Mon Jan  8 2001 JoungKyun Kim <http://www.oops.org>
- configure option miss typing fixed
- fixed pam file name to sshd2

* Thu Jan  4 2001 JoungKyun Kim <http://www.oops.org>
- updated version 2.4.0

* Fri Nov 16 2000 JoungKyun Kim <http://www.oops.org>
- fixed to don't create hostkey file

* Sat Oct 28 2000 JoungKyun Kim <http://www.oops.org>
- update version 2.3.0
- modified default config file

* Sat Jul 29 2000 JoungKyun Kim <http://www.oops.org>
- update version 2.2.0
- modified init script file
- modified default config file

* Tue Jan 25 2000 JoungKyun Kim <http://www.oops.org>
- modified default config file

* Wed Jun  2 1999 JoungKyun Kim <http://www.oops.org>
- Update to ssh-2.0.13
- add pam

* Fri Dec 11 1998 Miguel Armas <kuko@dis.ulpgc.es>
- Update to ssh-2.0.11

* Mon Dec 07 1998 Miguel Armas <kuko@dis.ulpgc.es>
- Keep out symlinks to avoid conflicts with SSHv1. Make symlinks on install
- Fix restart server...
- On last uninstall, make symlinks to SSHv1 utils if they exist...
- On last uninstall, configure sshd1 to start on boot...
- Add %doc to manpages
- Fix ownership in %doc files

* Sat Dec 05 1998 Miguel Armas <kuko@dis.ulpgc.es>
- Initial revision
